## libpve-http-server-perl 5.1.2

=== Makefile ===
DESTDIR=
PERL5DIR=${DESTDIR}/usr/share/perl5
DOCDIR=${DESTDIR}/usr/share/doc/${PACKAGE}

all:

install: PVE
	install -d -m 755 ${PERL5DIR}/PVE/APIServer
	install -m 0644 PVE/APIServer/AnyEvent.pm ${PERL5DIR}/PVE/APIServer
	install -m 0644 PVE/APIServer/Formatter.pm ${PERL5DIR}/PVE/APIServer
	install -m 0644 PVE/APIServer/Utils.pm ${PERL5DIR}/PVE/APIServer
	install -d -m 755 ${PERL5DIR}/PVE/APIServer/Formatter
	install -m 0644 PVE/APIServer/Formatter/Standard.pm ${PERL5DIR}/PVE/APIServer/Formatter
	install -m 0644 PVE/APIServer/Formatter/Bootstrap.pm ${PERL5DIR}/PVE/APIServer/Formatter
	install -m 0644 PVE/APIServer/Formatter/HTML.pm ${PERL5DIR}/PVE/APIServer/Formatter

.PHONY: clean distclean
distclean: clean
	rm -f examples/simple-demo.pem

clean:
	rm -rf examples/simple-demo.lck
	find . -name '*~' -exec rm {} ';'

=== debian/changelog ===
libpve-http-server-perl (5.1.2) bookworm; urgency=medium

  * fix #5391: proxy request: avoid "HTTP 599 Too many redirections" error
    that could occur due to long-running requests and bad timing during
    connection reuse. Disable connection reuse for all but GET requests that
    are proxied between different nodes, and allow one retry in this case.

    This can add a tiny bit of overhead if many PUT requests that are proxied
    to other nodes are issued with only a small delay between each other.
    However, such a high-frequency PUT request pattern is considered an edge
    case, and benchmarks show that the slowdown is about 2ms on average, which
    is often negligible compared to the actual time required to process the
    request.

 -- Proxmox Support Team <support@proxmox.com>  Fri, 04 Oct 2024 14:02:39 +0200

libpve-http-server-perl (5.1.1) bookworm; urgency=medium

  * handler: only allow downloads for annotated endpoints and remove support
    for directly returned download info

 -- Proxmox Support Team <support@proxmox.com>  Mon, 23 Sep 2024 11:07:22 +0200

libpve-http-server-perl (5.1.0) bookworm; urgency=medium

  * http: support the deflate compression content encoding

 -- Proxmox Support Team <support@proxmox.com>  Mon, 22 Apr 2024 13:14:26 +0200

libpve-http-server-perl (5.0.6) bookworm; urgency=medium

  * access control: avoid "uninitialized value" warning if using IP
    ranges

 -- Proxmox Support Team <support@proxmox.com>  Tue, 26 Mar 2024 09:16:48 +0100

libpve-http-server-perl (5.0.5) bookworm; urgency=medium

  * fix #4859: properly configure TLSv1.3 only mode

 -- Proxmox Support Team <support@proxmox.com>  Fri, 03 Nov 2023 12:06:31 +0100

libpve-http-server-perl (5.0.4) bookworm; urgency=medium

  * fix #4802: reduce CA lookups while proxying with OpenSSL as packaged in
    Debian 12 Bookworm.

  * avoid AnyEvent::AIO to fix CPU spinning if the pure-perl implementation
    libanyevent-aio-perl is installed, for example on development machines
    when trying to use the perl language server.

 -- Proxmox Support Team <support@proxmox.com>  Mon, 03 Jul 2023 09:38:56 +0200

libpve-http-server-perl (5.0.3) bookworm; urgency=medium

  * proxy request: handle missing content-type header

 -- Proxmox Support Team <support@proxmox.com>  Fri, 09 Jun 2023 18:58:05 +0200

libpve-http-server-perl (5.0.2) bookworm; urgency=medium

  * formatter/bootstrap: set SameSite attr of auth cookie to 'strict'

  * when proxying requests, preserve json formatting instead of converting to
    x-www-form-urlencoded

  * support actual arrays for array parameters, as a replacement for '-list' and
    '-alist' formats

 -- Proxmox Support Team <support@proxmox.com>  Wed, 07 Jun 2023 13:21:19 +0200

libpve-http-server-perl (5.0.1) bookworm; urgency=medium

  * fix regression in the html (bootstrap) based API debug explorer, which
    came in through a more strict pattern checking in a newer version of the
    used URL encoding library

 -- Proxmox Support Team <support@proxmox.com>  Sat, 03 Jun 2023 15:15:47 +0200

libpve-http-server-perl (5.0.0) bookworm; urgency=medium

  * switch over to native versioning

  * various small code and packaging clean ups

  * re-build for Debian 12 Bookworm based releases

 -- Proxmox Support Team <support@proxmox.com>  Wed, 17 May 2023 07:26:11 +0200

libpve-http-server-perl (4.2-3) bullseye; urgency=medium

  * file upload: don't always calculate MD5 for syslog message, rather log the
    file name instead,

  * explicitly disallow tmpfilename parameter in query URL

 -- Proxmox Support Team <support@proxmox.com>  Fri, 14 Apr 2023 16:27:07 +0200

libpve-http-server-perl (4.2-2) bullseye; urgency=medium

  * multipart upload: properly parse file parts without Content-Type

 -- Proxmox Support Team <support@proxmox.com>  Tue, 11 Apr 2023 14:44:03 +0200

libpve-http-server-perl (4.2-1) bullseye; urgency=medium

  * fix #4494: redirect incoming HTTP requests to HTTPS to avoid common
    pitfall when opening the Proxmox VE or Proxmox Mail Gateway web-interface
    for the first time

 -- Proxmox Support Team <support@proxmox.com>  Thu, 16 Mar 2023 16:57:59 +0100

libpve-http-server-perl (4.1-6) bullseye; urgency=medium

  * multipart upload: fix upload of files starting with newlines

  * multipart upload: don't fail on presebce of additional headers

  * multipart upload: loosen trailing-newline requirement from spec, as some
    more popular clients (e.g., postman) violate that rule.

  * fix #4344: http-server: fix regression that required the 'Content-Type' to
    be always present for multipart headers, while it wasn't used at all.

 -- Proxmox Support Team <support@proxmox.com>  Mon, 06 Mar 2023 13:39:57 +0100

libpve-http-server-perl (4.1-5) bullseye; urgency=medium

  * upload: re-allow having white-space in filenames

 -- Proxmox Support Team <support@proxmox.com>  Mon, 07 Nov 2022 16:43:31 +0100

libpve-http-server-perl (4.1-4) bullseye; urgency=medium

  * acknowledge content-disposition header

  * request: add missing early return to future proof error check

 -- Proxmox Support Team <support@proxmox.com>  Thu, 29 Sep 2022 14:37:05 +0200

libpve-http-server-perl (4.1-3) bullseye; urgency=medium

  * response: forbid linefeeds in response status message

  * proxy request: assert that API url starts with a slash

  * pass through streaming: only allow from privileged local pvedaemon as
    safety net

  * requests: assert that there is no @ in the URLs authority

 -- Proxmox Support Team <support@proxmox.com>  Sat, 02 Jul 2022 09:16:21 +0200

libpve-http-server-perl (4.1-2) bullseye; urgency=medium

  * tls: log failure to apply TLS 1.3 ciphers

  * html formatter: encode href attributes for API debug viewer

 -- Proxmox Support Team <support@proxmox.com>  Tue, 17 May 2022 16:40:12 +0200

libpve-http-server-perl (4.1-1) bullseye; urgency=medium

  * web socket: guard disconnect block check properly



=== debian/control ===
Source: libpve-http-server-perl
Section: perl
Priority: optional
Maintainer: Proxmox Support Team <support@proxmox.com>
Build-Depends: debhelper-compat (= 13), perl,
Standards-Version: 4.6.2
Homepage: https://www.proxmox.com

Package: libpve-http-server-perl
Architecture: all
Depends: libanyevent-http-perl,
         libanyevent-perl (>= 7.140-3),
         libcrypt-ssleay-perl,
         libhtml-parser-perl,
         libhttp-date-perl,
         libhttp-message-perl,
         libio-socket-ssl-perl,
         libjs-bootstrap,
         libjs-jquery,
         libjson-perl,
         libnet-ip-perl,
         libpve-common-perl (>= 8.0.2),
         liburi-perl,
         ${misc:Depends},
         ${perl:Depends},
Breaks: libpve-storage-perl (<< 8.2.5),
        pmg-api (<< 8.1.4),
        pve-manager (<< 8.2.7),
Description: Proxmox Asynchrounous HTTP Server Implementation
 This package is used as base to implement the REST API in all perl based
 Proxmox projects.
